The "testing" flag for Service Binding (SVCB) Records
Internet-Draft draft-manuben-svcb-testing-flag-00
Benjamin M. Schwartz
Meta Platforms, Inc.
ietf@bemasc.net
Manu Bretelle
Meta Platforms, Inc.
chantr4@gmail.com
12 February 2024
This draft defines a flag to mark a service endpoint as being potentially unreliable. This flag may be useful when introducing new features that could have a negative impact on availability.
About This Document
Status information for this document may be found at https://datatracker.ietf.org/doc/draft-manuben-svcb-testing-flag/.
Source for this draft and an issue tracker can be found at https://github.com/bemasc/svcb-testing-flag.
Introduction
The Service Binding (SVCB) DNS record type [RFC9460], and SVCB-compatible types like HTTPS, convey a collection of endpoints that can provide a service, along with metadata about each of those endpoints. This metadata can indicate protocol features that are available and supported on those endpoints.
In most cases, advertising new features is unlikely to render the service unavailable. Clients that are unaware of these features will ignore them, and clients that are aware will fall back to other SVCB records or other connection modes if the feature doesn't work. However, for security-enhancing features, this fallback behavior would create a loss of security against an active attacker, so it is generally not allowed. Instead, if the feature does not work as expected, the client will "fail closed". This behavior can make it challenging to deploy security-enhancing features, as the initial public deployment can create an outage if the service is misconfigured.
This document defines a new SVCB SvcParam to help service operators offer new security features. By marking these features as still being tested, the operator advises the client to interpret problems as an accidental failure by the operator, not a malicious action by an active attacker.
Conventions and Definitions
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
Specification
The "testing" flag is a SvcParam that always has an empty value in presentation and wire format. When present, this flag indicates that this ServiceMode record is subject to outages, and clients SHOULD NOT interpret connection failures as evidence of an active attack.
Service owners SHOULD ensure that this flag is mandatory, either explicitly (by adding mandatory=testing to the SvcParams) or implicitly if this parameter is "automatically mandatory" for the protocol mapping. Future protocol mappings SHOULD make this SvcParam "automatically mandatory".
Interaction with SvcPriority
Clients SHOULD NOT alter the priority of SVCB records based on the presence of the "testing" flag. Deprioritizing SVCB records with this flag would result in little or no user traffic making use of the testing record, which would defeat the goal of validating that new features function correctly for real users.
Example: Encrypted DNS Protocol
Consider the case of a plaintext DNS server operator at "dns.example.com" who would like to announce support for DNS over TLS [RFC7858]. Per [RFC9461], this operator could publish a record like:

_dns.dns.example.com. SVCB 1 . alpn=dot

Clients following [RFC9461] would retrieve this record, observe that DNS over TLS is available, and attempt to use it on TCP port 853. If the TLS session cannot be established for any reason, a compliant client will not fall back to plaintext DNS on UDP port 53, because the failure could indicate an active attack ([RFC9461], Section 8.2). If the operator of "dns.example.com" does not have operational confidence in their DNS over TLS service, this failure mode could raise concerns about the potential consequences of offering this new service.
To reduce the risk associated with this new service, the operator could instead use the new "testing" flag as follows:

_dns.dns.example.com. SVCB 1 . alpn=dot testing mandatory=testing

Clients that do not implement this specification will ignore the record because it specifies an unrecognized mandatory SvcParam. They will continue to use plaintext DNS. Clients that respect the "testing" flag will attempt to use DNS over TLS, but they will fall back to plaintext DNS if DNS over TLS is non-functional.
Security Considerations
Use of the "testing" flag explicitly disables SVCB's defense against active attackers. This is a loss in security. However, the intent of this flag is to facilitate the deployment of security-enhancing protocols. Downgrade-resistant security is achieved only when the testing period is complete and the "testing" flag is removed.
IANA Considerations
IANA is requested to add this entry to the SVCB SvcParams Registry:
Number | Name | Meaning | Change Controller | Reference
TBD | testing | Endpoint may be unreliable | IETF | (This document)
References
Normative References
[RFC9460]

Service Binding and Parameter Specification via the DNS (SVCB and HTTPS Resource Records)
B. Schwartz
M. Bishop
E. Nygren
November 2023
RFC 9460
DOI 10.17487/RFC9460
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
S. Bradner
March 1997
BCP 14
RFC 2119
DOI 10.17487/RFC2119
[RFC8174]

Ambiguity of Uppercase vs Lowercase in RFC 2119 Key Words
B. Leiba
May 2017
BCP 14
RFC 8174
DOI 10.17487/RFC8174
Informative References
[RFC7858]

Specification for DNS over Transport Layer Security (TLS)
Z. Hu
L. Zhu
J. Heidemann
A. Mankin
D. Wessels
P. Hoffman
May 2016
RFC 7858
DOI 10.17487/RFC7858
[RFC9461]

Service Binding Mapping for DNS Servers
B. Schwartz
November 2023
RFC 9461
DOI 10.17487/RFC9461
[I-D.dnsop-deleg]

Extensible Delegation for DNS
Tim April
Petr Špaček
Akamai Technologies
Ralf Weber
Akamai Technologies
David C Lawrence
Salesforce
23 January 2024
Internet-Draft draft-dnsop-deleg-00
Acknowledgments
This proposal is inspired by deployment considerations related to [I-D.dnsop-deleg].